"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultMiddleWare = exports.SocketMiddleware = exports.Middleware = exports.SocketController = exports.JsonController = exports.Controller = void 0;
var Controller = function (options, responseType) {
    return function (target) {
        var url = '/';
        if (typeof options === 'string') {
            url = options;
        }
        else if (options && options.prefix) {
            url = options.prefix;
        }
        Object.defineProperty(target, 'easy-ts-api:controller', {
            value: true
        });
        Object.defineProperty(target, 'baseUrl', {
            value: url
        });
        Object.defineProperty(target, 'render', {
            value: responseType !== null && responseType !== void 0 ? responseType : 'text/html'
        });
    };
};
exports.Controller = Controller;
var JsonController = function (baseUrl) {
    return (0, exports.Controller)(baseUrl, 'application/json');
};
exports.JsonController = JsonController;
var SocketController = function (options) {
    return function (target) {
        var namespace = '/';
        var room;
        if (typeof options === 'string') {
            namespace = options;
        }
        else if (options && options.namespace) {
            namespace = options.namespace;
        }
        if (options && typeof options !== 'string' && options.room) {
            room = options.room;
        }
        Object.defineProperty(target, 'namespace', {
            value: namespace
        });
        Object.defineProperty(target, 'room', {
            value: room
        });
    };
};
exports.SocketController = SocketController;
var Middleware = function () {
    return function (target) {
        Object.defineProperty(target, 'easy-ts-api:middleware', {
            value: true
        });
    };
};
exports.Middleware = Middleware;
var SocketMiddleware = function () {
    return function (target) {
        Object.defineProperty(target, 'easy-ts-api:socket-middleware', {
            value: true
        });
    };
};
exports.SocketMiddleware = SocketMiddleware;
var DefaultMiddleWare = /** @class */ (function () {
    function DefaultMiddleWare() {
    }
    DefaultMiddleWare.prototype.use = function (req, res, next) {
        console.log('Default middleware');
        next();
    };
    return DefaultMiddleWare;
}());
exports.DefaultMiddleWare = DefaultMiddleWare;
//# sourceMappingURL=Controller.js.map