"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.All = exports.Put = exports.Post = exports.Get = exports.RenderFile = exports.Render = exports.OpenApi = exports.Use = void 0;
var methodFactory = function (method) {
    return function (url) {
        return function (target, propertyKey, descriptor) {
            var _a;
            var value = descriptor.value;
            if (target['routes']) {
                target['routes'][propertyKey] = {
                    method: method,
                    url: url,
                    render: null
                };
            }
            else {
                target['routes'] = (_a = {},
                    _a[propertyKey] = {
                        method: method,
                        url: url,
                        render: null
                    },
                    _a);
            }
            descriptor.value = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, value.apply(this, args)];
                            case 1: return [2 /*return*/, _a.sent()];
                        }
                    });
                });
            };
            return target;
        };
    };
};
var Use = function (middleware) {
    return function (target, propertyKey, descriptor) {
        if (!target['middlewares']) {
            target['middlewares'] = {};
        }
        if (!target['classmiddlewares']) {
            target['classmiddlewares'] = [];
        }
        if (propertyKey) {
            if (!target['middlewares'][propertyKey]) {
                target['middlewares'][propertyKey] = [];
            }
            target['middlewares'][propertyKey].push(middleware);
        }
        else {
            target['classmiddlewares'].push(middleware);
        }
        return target;
    };
};
exports.Use = Use;
var OpenApi = function (options) {
    return function (target, propertyKey, descriptor) {
        if (!target['paths']) {
            target['paths'] = {};
        }
        var route = target['routes'][propertyKey];
        var operationId = String().concat(target.constructor.name, '.', propertyKey);
        options.operationId = operationId;
        options.tags = [String(target.constructor.name).replace('Controller', '')];
        target['paths'][propertyKey] = options;
        return target;
    };
};
exports.OpenApi = OpenApi;
var Render = function (file) {
    return function (target, propertyKey, descriptor) {
        if (target['routes']) {
            target['routes'][propertyKey]['render'] = file;
        }
        return target;
    };
};
exports.Render = Render;
var RenderFile = function (storage, download) {
    return function (target, propertyKey, descriptor) {
        if (target['routes']) {
            target['routes'][propertyKey]['renderfile'] = {
                storage: storage,
                download: download
            };
        }
        return target;
    };
};
exports.RenderFile = RenderFile;
exports.Get = methodFactory('get');
exports.Post = methodFactory('post');
exports.Put = methodFactory('put');
exports.All = methodFactory('all');
//# sourceMappingURL=Method.js.map