"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UseOnSocket = exports.SocketAuth = exports.SocketHeaders = exports.SocketQueryParam = exports.SocketId = exports.Clients = exports.ConnectedSocket = exports.MessageBody = exports.EmitOnFail = exports.EmitOnSuccess = exports.OnDisconnect = exports.OnConnect = exports.OnEvent = void 0;
var OnEvent = function (event) {
    return function (target, propertyKey, descriptor) {
        var _a;
        var value = descriptor.value;
        if (target['events']) {
            target['events'][propertyKey] = event;
        }
        else {
            target['events'] = (_a = {},
                _a[propertyKey] = event,
                _a);
        }
        descriptor.value = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, value.apply(this, args)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        return target;
    };
};
exports.OnEvent = OnEvent;
var OnConnect = function () {
    return (0, exports.OnEvent)('connection');
};
exports.OnConnect = OnConnect;
var OnDisconnect = function () {
    return (0, exports.OnEvent)('disconnect');
};
exports.OnDisconnect = OnDisconnect;
var Emit = function (key) {
    return function (event) {
        return function (target, propertyKey, descriptor) {
            var _a;
            if (target[key]) {
                target[key][propertyKey] = event;
            }
            else {
                target[key] = (_a = {},
                    _a[propertyKey] = event,
                    _a);
            }
            return target;
        };
    };
};
exports.EmitOnSuccess = Emit('success');
exports.EmitOnFail = Emit('error');
var paramsFactory = function (ptype) {
    return function (key) {
        return function (target, propertyKey, parameterIndex) {
            var _a;
            var t = Reflect.getMetadata("design:type", target, propertyKey.toString());
            var data = {
                param: ptype,
                value: key,
                type: t
            };
            if (target['params']) {
                if (!target['params'][propertyKey]) {
                    target['params'][propertyKey] = [];
                }
                target['params'][propertyKey][parameterIndex] = data;
            }
            else {
                target['params'] = (_a = {},
                    _a[propertyKey] = [],
                    _a);
                target['params'][propertyKey][parameterIndex] = data;
            }
            return target;
        };
    };
};
exports.MessageBody = paramsFactory('data');
exports.ConnectedSocket = paramsFactory('socket');
exports.Clients = paramsFactory('clients');
exports.SocketId = paramsFactory('id');
exports.SocketQueryParam = paramsFactory('query');
exports.SocketHeaders = paramsFactory('headers');
exports.SocketAuth = paramsFactory('auth');
// Middleware
var UseOnSocket = function (middleware) {
    return function (target, propertyKey, descriptor) {
        if (!target['middlewares']) {
            target['middlewares'] = {};
        }
        if (!target['classmiddlewares']) {
            target['classmiddlewares'] = [];
        }
        if (propertyKey) {
            if (!target['middlewares'][propertyKey]) {
                target['middlewares'][propertyKey] = [];
            }
            target['middlewares'][propertyKey].push(middleware);
        }
        else {
            target['classmiddlewares'].push(middleware);
        }
        return target;
    };
};
exports.UseOnSocket = UseOnSocket;
//# sourceMappingURL=socket.js.map