"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.registerMiddleware = exports.registerController = void 0;
var cookie_1 = __importDefault(require("cookie"));
var path_to_regexp_1 = require("path-to-regexp");
var class_transformer_1 = require("class-transformer");
var mime_1 = __importDefault(require("mime"));
var path_1 = require("path");
var fs_1 = __importDefault(require("fs"));
var bindParams = function (params, req, res, isFastify, cookieparams, app) {
    var methodParams = [];
    params === null || params === void 0 ? void 0 : params.forEach(function (value) {
        var param;
        switch (value.param) {
            case 'io':
                param = isFastify ? app.io : app.get('io');
                break;
            case 'req':
                param = isFastify ? req.raw : req;
                break;
            case 'res':
                param = res;
                break;
            case 'params':
                param = req[value.param];
                break;
            case 'cookies':
                var data = isFastify ? req.raw[value.param] : req[value.param];
                data.set = function (key, value) {
                    res['cookie'](cookie_1.default.serialize(key, String(value), cookieparams !== null && cookieparams !== void 0 ? cookieparams : {
                        httpOnly: true,
                        maxAge: 60 * 60 * 24 * 7
                    }));
                };
                param = data;
                break;
            case 'files':
                var r = isFastify ? req.raw : req;
                param = r[value.param];
                param = param.reduce(function (p, n) {
                    p[n.fieldname] = n;
                    return p;
                }, {});
                break;
            case 'renderer':
                param = req.app.get('renderer');
                break;
            default:
                var request = isFastify ? req.raw : req;
                param = request[value.param];
        }
        // sey value assigne object
        var currentValue = value.value ? param[value.value] : param;
        if (currentValue && value.type && value.type != Object) {
            try {
                currentValue = (0, class_transformer_1.plainToInstance)(value.type, currentValue, { enableCircularCheck: true });
            }
            catch (e) {
                console.log(e);
            }
        }
        methodParams.push(currentValue);
    });
    return methodParams;
};
var registerController = function (app, object, isFastify, spec, cookieparams) { return __awaiter(void 0, void 0, void 0, function () {
    var baseUrl, renderType, properties, classmiddlewares, objectMiddlewares, _loop_1, types, _i, properties_1, a;
    var _a, _b, _c, _d;
    return __generator(this, function (_e) {
        switch (_e.label) {
            case 0:
                if (!Object.getOwnPropertyDescriptors(object)['easy-ts-api:controller'])
                    return [2 /*return*/, spec];
                baseUrl = Object.getOwnPropertyDescriptors(object)['baseUrl'].value;
                renderType = Object.getOwnPropertyDescriptors(object)['render'].value;
                properties = Object.getOwnPropertyNames(object.prototype);
                classmiddlewares = (_a = object['classmiddlewares']) !== null && _a !== void 0 ? _a : [];
                objectMiddlewares = object.prototype['middlewares'];
                _loop_1 = function (a) {
                    var method, route_1, params_1, middlewares, uses, applymiddleware, path, keys, toPath, swaggerRoute, _f, keys_1, key, body, jsonBody, _g, body_1, b, t;
                    var _h;
                    return __generator(this, function (_j) {
                        switch (_j.label) {
                            case 0:
                                method = object.prototype[a];
                                if (!(typeof method === 'function' && a !== 'constructor')) return [3 /*break*/, 3];
                                route_1 = object.prototype['routes'][a];
                                params_1 = object.prototype['params'] ? (_b = object.prototype['params'][a]) !== null && _b !== void 0 ? _b : [] : [];
                                types = Reflect.getMetadata("design:paramtypes", object.prototype, a);
                                params_1 = params_1.reduce(function (prev, next, index) {
                                    next.type = types[index];
                                    prev.push(next);
                                    return prev;
                                }, []);
                                middlewares = objectMiddlewares ? (_c = objectMiddlewares[a]) !== null && _c !== void 0 ? _c : [classmiddlewares] : [classmiddlewares];
                                middlewares = Array().concat(classmiddlewares, middlewares);
                                uses = middlewares.reduce(function (p, n) {
                                    if (n && n.prototype) {
                                        p.push(n.prototype.use);
                                    }
                                    return p;
                                }, []);
                                applymiddleware = isFastify ? { preHandler: uses } : uses;
                                route_1.url = String().concat(baseUrl, route_1.url);
                                path = object.prototype['paths'] ? (_d = object.prototype['paths'][a]) !== null && _d !== void 0 ? _d : null : null;
                                if (!path) return [3 /*break*/, 2];
                                keys = [];
                                return [4 /*yield*/, (0, path_to_regexp_1.pathToRegexp)(route_1.url, keys)];
                            case 1:
                                _j.sent();
                                if ('parameters' in path === false) {
                                    path.parameters = [];
                                }
                                toPath = (0, path_to_regexp_1.compile)(route_1.url);
                                swaggerRoute = route_1.url;
                                for (_f = 0, keys_1 = keys; _f < keys_1.length; _f++) {
                                    key = keys_1[_f];
                                    path.parameters.push({
                                        name: key['name'],
                                        in: 'path',
                                        required: true
                                    });
                                    swaggerRoute = toPath((_h = {}, _h[key['name']] = "{".concat(key['name'], "}"), _h));
                                }
                                // openAPi
                                if (spec) {
                                    if (!spec.paths) {
                                        spec.paths = {};
                                    }
                                    if (!spec.paths[swaggerRoute]) {
                                        spec.paths[swaggerRoute] = {};
                                    }
                                    body = params_1.filter(function (e) { return e.param === 'body'; });
                                    path.produces = [
                                        "application/xml",
                                        "application/json"
                                    ];
                                    jsonBody = [];
                                    for (_g = 0, body_1 = body; _g < body_1.length; _g++) {
                                        b = body_1[_g];
                                        t = Reflect.getMetadata('class:schema', b.type);
                                        if (t) {
                                            jsonBody = Object.values(t.properties);
                                            break;
                                        }
                                    }
                                    if (route_1.method === 'all') {
                                        spec.paths[swaggerRoute]['get'] = path;
                                        spec.paths[swaggerRoute]['put'] = path;
                                        spec.paths[swaggerRoute]['delete'] = path;
                                        path["consumes"] = ["multipart/form-data"];
                                        if (Object.keys(jsonBody).length > 0) {
                                            path.parameters = path.parameters.concat(jsonBody);
                                        }
                                        spec.paths[swaggerRoute]['post'] = path;
                                    }
                                    else if (route_1.method === 'post') {
                                        path["consumes"] = ["multipart/form-data"];
                                        if (Object.keys(jsonBody).length > 0) {
                                            path.parameters = path.parameters.concat(jsonBody);
                                        }
                                        spec.paths[swaggerRoute][route_1.method] = path;
                                    }
                                    else {
                                        spec.paths[swaggerRoute][route_1.method] = path;
                                    }
                                }
                                _j.label = 2;
                            case 2:
                                //End open api
                                // routing configuration
                                app[route_1.method](route_1.url, applymiddleware, function (req, res) {
                                    var methodParams = bindParams(params_1, req, res, isFastify, cookieparams, app);
                                    method.apply(void 0, methodParams).then(function (data) {
                                        var _a;
                                        if (renderType) {
                                            res.type(renderType);
                                        }
                                        if (route_1.renderfile) {
                                            var renderType_1 = mime_1.default.getType(data);
                                            if (route_1.renderfile.download) {
                                                res.header('Content-Disposition', 'attachment;filename=' + data);
                                            }
                                            if (renderType_1)
                                                res.type(renderType_1);
                                            var filepath = (0, path_1.join)(process.cwd(), (_a = route_1.renderfile.storage) !== null && _a !== void 0 ? _a : '', data);
                                            if (!isFastify) {
                                                res.download(filepath);
                                            }
                                            else {
                                                var stream = fs_1.default.readFileSync(filepath);
                                                res = res.type(renderType_1 !== null && renderType_1 !== void 0 ? renderType_1 : 'application/octet-stream').send(stream);
                                            }
                                        }
                                        else if (route_1.render && !isFastify) {
                                            res.render(route_1.render, data);
                                        }
                                        else {
                                            res.send(data);
                                        }
                                    }).catch(function (err) {
                                        var _a;
                                        res.send({ error: (_a = err.message) !== null && _a !== void 0 ? _a : err }).status(500);
                                    });
                                });
                                _j.label = 3;
                            case 3: return [2 /*return*/];
                        }
                    });
                };
                _i = 0, properties_1 = properties;
                _e.label = 1;
            case 1:
                if (!(_i < properties_1.length)) return [3 /*break*/, 4];
                a = properties_1[_i];
                return [5 /*yield**/, _loop_1(a)];
            case 2:
                _e.sent();
                _e.label = 3;
            case 3:
                _i++;
                return [3 /*break*/, 1];
            case 4: return [2 /*return*/, spec];
        }
    });
}); };
exports.registerController = registerController;
var registerMiddleware = function (app, object, route) {
    if (route === void 0) { route = "/"; }
    return __awaiter(void 0, void 0, void 0, function () {
        var propertiesDescriptors;
        return __generator(this, function (_a) {
            propertiesDescriptors = Object.getOwnPropertyDescriptors(object.constructor);
            if (!propertiesDescriptors['easy-ts-api:middleware'])
                return [2 /*return*/];
            app.app['use'](route, object.use);
            return [2 /*return*/];
        });
    });
};
exports.registerMiddleware = registerMiddleware;
//# sourceMappingURL=controller-factory.js.map