"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.registerSocket = void 0;
var bindParams = function (params, socket, data, io) {
    var methodParams = [];
    params === null || params === void 0 ? void 0 : params.forEach(function (value, index) {
        var param;
        switch (value.param) {
            case 'socket':
                param = socket;
                break;
            case 'data':
                param = data;
                break;
            case 'ids':
                param = io.engine.clientsCount;
                break;
            case 'clients':
                param = io.fetchSockets();
                break;
            case 'id':
                param = socket.id;
                break;
            case 'auth':
                param = socket.handshake.auth;
                break;
            case 'headers':
                param = socket.handshake.headers;
                break;
            case 'query':
                param = socket.handshake.query;
                break;
        }
        // sey value assigne object
        var currentValue = value.value ? param[value.value] : param;
        if (value.type)
            Object.assign(currentValue, value.type);
        methodParams.push(currentValue);
    });
    return methodParams;
};
var registerSocket = function (io, object) { return __awaiter(void 0, void 0, void 0, function () {
    var properties, method, namespace, room, classmiddlewares, objectMiddlewares;
    var _a, _b, _c;
    return __generator(this, function (_d) {
        properties = Object.getOwnPropertyNames(object.prototype);
        namespace = (_a = Object.getOwnPropertyDescriptor(object, 'namespace')) === null || _a === void 0 ? void 0 : _a.value;
        room = (_b = Object.getOwnPropertyDescriptor(object, 'room')) === null || _b === void 0 ? void 0 : _b.value;
        classmiddlewares = (_c = object['classmiddlewares']) !== null && _c !== void 0 ? _c : [];
        objectMiddlewares = object.prototype['middlewares'];
        if (properties.includes('connection')) {
            method = object.prototype['connection'];
        }
        io.of(namespace).on('connection', function (socket) { return __awaiter(void 0, void 0, void 0, function () {
            var paramsConnection, typesConnection, bindedParams, _loop_1, types, _i, properties_1, p, state_1;
            var _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (room)
                            socket.join(room);
                        if (!method) return [3 /*break*/, 2];
                        paramsConnection = object.prototype['params'] ? (_a = object.prototype['params']['connection']) !== null && _a !== void 0 ? _a : [] : [];
                        typesConnection = Reflect.getMetadata("design:paramtypes", object.prototype, 'connection');
                        paramsConnection = paramsConnection.reduce(function (prev, next, index) {
                            next.type = typesConnection[index];
                            prev.push(next);
                            return prev;
                        }, []);
                        bindedParams = bindParams(paramsConnection, socket, "user connected", io);
                        return [4 /*yield*/, method.apply(void 0, bindedParams)];
                    case 1:
                        _d.sent();
                        _d.label = 2;
                    case 2:
                        _loop_1 = function (p) {
                            var callback = object.prototype[p];
                            if (typeof method === 'function' && p !== 'constructor') {
                                var event_1 = object.prototype['events'][p];
                                if (!event_1 || p === "connection")
                                    return "continue";
                                var params_1 = object.prototype['params'] ? (_b = object.prototype['params'][p]) !== null && _b !== void 0 ? _b : [] : [];
                                types = Reflect.getMetadata("design:paramtypes", object.prototype, p);
                                params_1 = params_1.reduce(function (prev, next, index) {
                                    next.type = types[index];
                                    prev.push(next);
                                    return prev;
                                }, []);
                                var defaultMiddlewares = objectMiddlewares ? (_c = objectMiddlewares[p]) !== null && _c !== void 0 ? _c : [] : [];
                                var socketmiddlewares = Array().concat(classmiddlewares, defaultMiddlewares);
                                for (var _e = 0, socketmiddlewares_1 = socketmiddlewares; _e < socketmiddlewares_1.length; _e++) {
                                    var m = socketmiddlewares_1[_e];
                                    if (!Object.getOwnPropertyDescriptors(m)['easy-ts-api:socket-middleware'])
                                        return { value: void 0 };
                                    if (m.prototype)
                                        socket.use(m.prototype.use);
                                }
                                // register all socket 
                                socket.on("".concat(event_1), function (data) { return __awaiter(void 0, void 0, void 0, function () {
                                    var bindedParams, data_1, successEvents, e_1, errorEvents;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                bindedParams = bindParams(params_1, socket, data, io);
                                                _a.label = 1;
                                            case 1:
                                                _a.trys.push([1, 3, , 4]);
                                                return [4 /*yield*/, callback.apply(void 0, bindedParams)];
                                            case 2:
                                                data_1 = _a.sent();
                                                successEvents = object.prototype['success'];
                                                if (successEvents && successEvents[p]) {
                                                    socket.emit(successEvents[p], data_1);
                                                }
                                                return [3 /*break*/, 4];
                                            case 3:
                                                e_1 = _a.sent();
                                                errorEvents = object.prototype['errors'];
                                                if (errorEvents && errorEvents[p]) {
                                                    socket.emit(errorEvents[p], e_1.toString());
                                                }
                                                return [3 /*break*/, 4];
                                            case 4: return [2 /*return*/];
                                        }
                                    });
                                }); });
                            }
                        };
                        for (_i = 0, properties_1 = properties; _i < properties_1.length; _i++) {
                            p = properties_1[_i];
                            state_1 = _loop_1(p);
                            if (typeof state_1 === "object")
                                return [2 /*return*/, state_1.value];
                        }
                        return [2 /*return*/];
                }
            });
        }); });
        return [2 /*return*/];
    });
}); };
exports.registerSocket = registerSocket;
//# sourceMappingURL=socket-factory.js.map