"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.App = void 0;
var body_parser_1 = require("body-parser");
var cookie_parser_1 = __importDefault(require("cookie-parser"));
var cookie_session_1 = __importDefault(require("cookie-session"));
var multer_1 = __importDefault(require("multer"));
var path_1 = __importDefault(require("path"));
var glob_1 = __importDefault(require("glob"));
var _decorators_1 = require("../@decorators");
var sequelize_typescript_1 = require("sequelize-typescript");
var database_1 = __importDefault(require("../providers/database"));
var env_1 = require("./../utils/env");
var socket_resolver_1 = require("../@resolver/socket-resolver");
var globule = require('globule');
var App = /** @class */ (function () {
    function App() {
        this.middlewares = { "/": [] };
        this.spec = {
            swagger: '2.0',
            info: {
                title: 'API SERVER ',
                version: '1.0.0',
            },
            schemes: ["http", "https"],
            paths: {},
        };
        this.db = database_1.default;
    }
    App.prototype.setServerOption = function (options) {
        this.options = options;
    };
    App.prototype.configDatabaseOption = function (options) {
        this.syncOption = options;
    };
    App.prototype.initDatabase = function (config, sync) {
        var _a, _b, _c, _d, _e;
        if (sync === void 0) { sync = false; }
        return __awaiter(this, void 0, void 0, function () {
            var modelsFinds;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        this.databaseConfig = config;
                        // check if have database config
                        if (this.databaseConfig) {
                            this.db = new sequelize_typescript_1.Sequelize(this.databaseConfig);
                        }
                        // loads models 
                        if ((_a = this.options) === null || _a === void 0 ? void 0 : _a.models) {
                            modelsFinds = (_d = (_c = (_b = this.options) === null || _b === void 0 ? void 0 : _b.models) === null || _c === void 0 ? void 0 : _c.reduce(function (p, n) {
                                var _a;
                                var s = String(n) + String((_a = env_1.ENV.Get('EXTENSION')) !== null && _a !== void 0 ? _a : '.ts');
                                p.push(s);
                                return p;
                            }, [])) !== null && _d !== void 0 ? _d : [];
                            this.db.addModels(modelsFinds);
                        }
                        else {
                            this.db.addModels([path_1.default.join(process.cwd(), 'models/**/*Model') + String((_e = env_1.ENV.Get('EXTENSION')) !== null && _e !== void 0 ? _e : '.ts')]);
                        }
                        //authenticate database 
                        return [4 /*yield*/, this.db.authenticate()
                            // sync database with model 
                        ];
                    case 1:
                        //authenticate database 
                        _f.sent();
                        if (!sync) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.db.sync(this.syncOption ? this.syncOption : { alter: false })];
                    case 2:
                        _f.sent();
                        _f.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    App.prototype.serve = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.config()];
                    case 1:
                        _a.sent();
                        //register db to request
                        this.app['use'](function (req, res, next) {
                            req.db = _this.db;
                            next();
                        });
                        // setup 
                        return [4 /*yield*/, this.setup()];
                    case 2:
                        // setup 
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    App.prototype.config = function () {
        return __awaiter(this, void 0, void 0, function () {
            var app;
            return __generator(this, function (_a) {
                app = this.app;
                if (this.options && this.options.cors) {
                    app['use'](require('cors')());
                }
                // (this.app)['use'](json(this.options && this.options.json ? this.options.json : { limit: '150mb' }))
                app['use']((0, body_parser_1.urlencoded)(this.options && this.options.urlencoded ? this.options.urlencoded : { extended: true }));
                app['use']((0, cookie_parser_1.default)());
                app['use']((0, cookie_session_1.default)({
                    name: 'session',
                    keys: this.options && this.options.sessionSecretKey ? this.options.sessionSecretKey : ['super_secret', 'super_secret'],
                }));
                return [2 /*return*/];
            });
        });
    };
    App.prototype.setupMiddleware = function (t) {
        var _a, _b, _c, _d;
        if (t === void 0) { t = 'before'; }
        return __awaiter(this, void 0, void 0, function () {
            var opts, middlewaresFind, middlewares, _i, middlewares_1, mwr, middlewareFunction, _e, _f, key, middlewares, _g, _h, middleware;
            return __generator(this, function (_j) {
                switch (_j.label) {
                    case 0:
                        opts = (_a = this.options) === null || _a === void 0 ? void 0 : _a.middlewares;
                        if (t === 'after') {
                            opts = (_b = this.options) === null || _b === void 0 ? void 0 : _b.afterMiddlewares;
                        }
                        if (this.options && Array.isArray(opts) && opts.length > 0 && opts.every(function (t) { return typeof t === "string"; })) {
                            middlewaresFind = (_d = (_c = opts) === null || _c === void 0 ? void 0 : _c.reduce(function (p, n) {
                                var _a;
                                var s = String(n) + String((_a = env_1.ENV.Get('EXTENSION')) !== null && _a !== void 0 ? _a : '.ts');
                                p.push(s);
                                return p;
                            }, [])) !== null && _d !== void 0 ? _d : [];
                            middlewares = globule.find(middlewaresFind);
                            for (_i = 0, middlewares_1 = middlewares; _i < middlewares_1.length; _i++) {
                                mwr = middlewares_1[_i];
                                middlewareFunction = require(mwr).default;
                                this.middlewares['/'].push(middlewareFunction);
                            }
                        }
                        else if (this.options) {
                            this.middlewares['/'].concat(opts);
                        }
                        _e = 0, _f = Object.keys(this.middlewares) || [];
                        _j.label = 1;
                    case 1:
                        if (!(_e < _f.length)) return [3 /*break*/, 6];
                        key = _f[_e];
                        middlewares = this.middlewares[key];
                        _g = 0, _h = middlewares || [];
                        _j.label = 2;
                    case 2:
                        if (!(_g < _h.length)) return [3 /*break*/, 5];
                        middleware = _h[_g];
                        return [4 /*yield*/, (0, _decorators_1.registerMiddleware)(this, new middleware(), key)];
                    case 3:
                        _j.sent();
                        _j.label = 4;
                    case 4:
                        _g++;
                        return [3 /*break*/, 2];
                    case 5:
                        _e++;
                        return [3 /*break*/, 1];
                    case 6:
                        this.middlewares = { "/": [] };
                        return [2 /*return*/];
                }
            });
        });
    };
    App.prototype.setup = function () {
        var _a, _b, _c, _d;
        return __awaiter(this, void 0, void 0, function () {
            var _i, _e, controller, directory, controllers, _f, controllers_1, ctrl, c, _g, c, _h, _j, _k, socketPath, directory, sockets, _l, sockets_1, socket, event_1, io;
            return __generator(this, function (_m) {
                switch (_m.label) {
                    case 0: 
                    // load middlewares 
                    return [4 /*yield*/, this.setupMiddleware('before')
                        // config file upload
                    ];
                    case 1:
                        // load middlewares 
                        _m.sent();
                        // config file upload
                        this.configMulter();
                        _i = 0, _e = (this.options && this.options.controllers ? this.options.controllers : []);
                        _m.label = 2;
                    case 2:
                        if (!(_i < _e.length)) return [3 /*break*/, 10];
                        controller = _e[_i];
                        if (!(typeof controller === "string")) return [3 /*break*/, 7];
                        directory = path_1.default.join(controller.toString() + String(String((_a = env_1.ENV.Get('EXTENSION')) !== null && _a !== void 0 ? _a : '.ts')));
                        controllers = glob_1.default.sync(directory);
                        _f = 0, controllers_1 = controllers;
                        _m.label = 3;
                    case 3:
                        if (!(_f < controllers_1.length)) return [3 /*break*/, 6];
                        ctrl = controllers_1[_f];
                        c = require(ctrl).default;
                        if (!Object.getOwnPropertyDescriptors(c)['easy-ts-api:controller']) return [3 /*break*/, 5];
                        _g = this;
                        return [4 /*yield*/, (0, _decorators_1.registerController)(this.app, c, (_b = this.isfastify) !== null && _b !== void 0 ? _b : false, this.spec, this.options && this.options.cookieParams ? this.options.cookieParams : undefined)];
                    case 4:
                        _g.spec = _m.sent();
                        _m.label = 5;
                    case 5:
                        _f++;
                        return [3 /*break*/, 3];
                    case 6: return [3 /*break*/, 9];
                    case 7:
                        c = controller;
                        if (!Object.getOwnPropertyDescriptors(c)['easy-ts-api:controller']) return [3 /*break*/, 9];
                        _h = this;
                        return [4 /*yield*/, (0, _decorators_1.registerController)(this.app, c, (_c = this.isfastify) !== null && _c !== void 0 ? _c : false, this.spec, this.options && this.options.cookieParams ? this.options.cookieParams : undefined)];
                    case 8:
                        _h.spec = _m.sent();
                        _m.label = 9;
                    case 9:
                        _i++;
                        return [3 /*break*/, 2];
                    case 10:
                        _j = 0, _k = (this.options && this.options.sockets ? this.options.sockets : []);
                        _m.label = 11;
                    case 11:
                        if (!(_j < _k.length)) return [3 /*break*/, 16];
                        socketPath = _k[_j];
                        if (!(typeof socketPath === "string")) return [3 /*break*/, 15];
                        directory = path_1.default.join(socketPath.toString() + (String((_d = env_1.ENV.Get('EXTENSION')) !== null && _d !== void 0 ? _d : '.ts')));
                        sockets = glob_1.default.sync(directory);
                        _l = 0, sockets_1 = sockets;
                        _m.label = 12;
                    case 12:
                        if (!(_l < sockets_1.length)) return [3 /*break*/, 15];
                        socket = sockets_1[_l];
                        event_1 = require(socket).default;
                        io = this.isfastify ? this.app.io : this.app.get('io');
                        return [4 /*yield*/, (0, socket_resolver_1.registerSocket)(io, event_1)];
                    case 13:
                        _m.sent();
                        _m.label = 14;
                    case 14:
                        _l++;
                        return [3 /*break*/, 12];
                    case 15:
                        _j++;
                        return [3 /*break*/, 11];
                    case 16: 
                    // setup openapi
                    return [4 /*yield*/, this.configOpenApiMiddleware()
                        //after middleware
                    ];
                    case 17:
                        // setup openapi
                        _m.sent();
                        //after middleware
                        return [4 /*yield*/, this.setupMiddleware('after')];
                    case 18:
                        //after middleware
                        _m.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    App.prototype.configMulter = function () {
        return __awaiter(this, void 0, void 0, function () {
            var storage, upload;
            var _this = this;
            return __generator(this, function (_a) {
                storage = multer_1.default.diskStorage({
                    destination: function (req, file, cb) {
                        var _a, _b, _c, _d;
                        cb(null, path_1.default.join(String((_b = (_a = _this.options) === null || _a === void 0 ? void 0 : _a.staticFolder) !== null && _b !== void 0 ? _b : path_1.default.join(process.cwd(), 'public')), String((_d = (_c = _this.options) === null || _c === void 0 ? void 0 : _c.uploadFolder) !== null && _d !== void 0 ? _d : 'uploads/')));
                    },
                    filename: function (req, file, cb) {
                        var ext = file.originalname.substring(file.originalname.lastIndexOf('.'), file.originalname.length);
                        var uniqueSuffix = Date.now() + '_' + Math.round(Math.random() * 1E9) + ext;
                        cb(null, file.fieldname + '_' + uniqueSuffix);
                    }
                });
                upload = (0, multer_1.default)(this.options && this.options.uploadOption ? this.options.uploadOption : { storage: storage });
                if (this.isfastify) {
                    this.app['use']('/', upload.any());
                }
                else {
                    this.app['use'](upload.any());
                }
                return [2 /*return*/];
            });
        });
    };
    App.prototype.setMiddlewares = function (middlewares) {
        this.middlewares = middlewares;
    };
    App.prototype.use = function (middleware, callback) {
        if (middleware instanceof String) {
            this.middlewares[String(middleware)].push(callback);
        }
        else {
            this.middlewares['/'].push(middleware);
        }
    };
    App.prototype.configOpenAPi = function (openapiOptions) {
        this.openapiOptions = openapiOptions;
        this.spec = {
            swagger: '2.0.0',
            info: this.openapiOptions ? this.openapiOptions.options : {
                title: 'API SERVER ',
                version: '3.0.0'
            },
            paths: {},
        };
    };
    App.prototype.configOpenApiMiddleware = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    return App;
}());
exports.App = App;
//# sourceMappingURL=server.js.map